﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace ContainersMVVM
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			var source = new ContainerGraphSource();

			var container = new ContainerViewModel();
			var item = new NodeViewModelBase();

			source.AddNode(item);
			container.AddItem(item);
			source.AddNode(container);

			diagram.GraphSource = source;
		}
	}

	public class ContainerGraphSource : ObservableGraphSourceBase<NodeViewModelBase, LinkViewModelBase<NodeViewModelBase>>
	{

	}

	public class ContainerViewModel : ContainerNodeViewModelBase<NodeViewModelBase>
	{

	}

	public class MyDiagram : RadDiagram
	{
		protected override Telerik.Windows.Diagrams.Core.IShape GetShapeContainerForItemOverride(object item)
		{
			if (item is ContainerViewModel)
				return new RadDiagramContainerShape();
			else
				return base.GetShapeContainerForItemOverride(item);
		}
	}
}
